require('player')
-------------------------------------------------------------------------------------
------------------------------ Arc Enemy Spawning -----------------------------------
-------------------------------------------------------------------------------------


arcenemy_speed = 200

arcenemies = {}



arcspawntimer = 0
print(spawntimer)
function arcenemiesAppear(dt)
	arcspawntimer = arcspawntimer + dt
	if arcspawntimer >= 10 then
    arcenemiesSpawn(650, 25, "arc")
    arcspawntimer = 0

  end
end

function arcenemiesSpawn(x,y,dir) 		-- this function actually spawns/generates the enemies
	table.insert(arcenemies, {width = 20, height = 50, x = 500, y = 0, dir = dir, timer = 0})
	table.insert(arcenemies, {width = 20, height = 50, x = 600, y = 50, dir = dir, timer = 1})
	table.insert(arcenemies, {width = 20, height = 50, x = 700, y = 110, dir = dir, timer = 2})
	table.insert(arcenemies, {width = 20, height = 50, x = 800, y = 170, dir = dir, timer = 3})
end



function arcenemiesMove(dt)					    -- This function and for loop sets the enemy speed, and also removes any enemies that
	for ii, vv in ipairs(arcenemies) do			-- are below 600 pixels on the y axis
		if vv.dir == "arc" then
			vv.y = vv.y + (arcenemy_speed/2) * dt
			vv.x = vv.x - (arcenemy_speed*1.5) * dt
		end
		if vv.y > 800 then
			table.remove(arcenemies, ii)
		end
		if vv.x < -64 then
			table.remove(arcenemies, ii)
		end
	end
end

function enemiesDraw()
	for ii,vv in ipairs(arcenemies) do
		love.graphics.setColor(255,0,255)
			love.graphics.rectangle("line", vv.x + 10, vv.y, vv.width, vv.height)
		love.graphics.setColor(255,255,255)
	end
end

-------------------------------------------------------------------------------------
---------------------------------- Arc Enemy Weapons ------------------------------------
-------------------------------------------------------------------------------------


arcenemybullet_speed = 600
arcenemybullets = {}

function arcenemybulletsSpawn(x,y,dir)
	table.insert(arcenemybullets, {width = 8, height = 8, x = x + 12, y = y + 25, dir = dir})

end

	function arcenemiesFiringupdate(dt)
		for i,v in ipairs(arcenemies) do
				v.timer = v.timer + 1
				if v.timer > 30 then
					arcenemybulletsSpawn(v.x, v.y, "down")
					v.timer = 0
				end
		end
	end

function arcenemybulletsDraw()							-- this code draws the enemy bullets to the screen
	for i,v in ipairs(arcenemybullets) do
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill", v.x,v.y,v.width,v.height)
		love.graphics.setColor(255,255,255)
	end
end

function arcupdateEnemyBullets(dt)

	for i,v in ipairs(arcenemybullets) do
			if v.dir == "down" then
					v.y = v.y + arcenemybullet_speed * dt -- this sets the speed of the rocket
			end
				if v.y > 700 then
						table.remove(arcenemybullets, i)
				end
	end

end

function arcEnemiesUPDATE(dt)
	arcenemiesMove(dt)
	arcenemiesAppear(dt)
	arcupdateEnemyBullets(dt)
	arcenemiesFiringupdate(dt)
end

function arcEnemiesDRAW()
	enemiesDraw()
	arcenemybulletsDraw()
end
