require('player')
-------------------------------------------------------------------------------------
---------------------------------- Collisions ---------------------------------------
-------------------------------------------------------------------------------------
--enemiesdead = {}

function collisionUpdate(dt)

	for ii,vv in ipairs(enemybullets) do             -- This checks whether any enemy bullets have hit the player
			if  (vv.x + vv.width) >= player.x and
			vv.x <= (player.x + player.width) and
			(vv.y + vv.height) >= player.y and
			vv.y <= (player.y + player.height) then
				player.streak = 0
				player.health = player.health - 1
				table.remove(enemybullets, ii)
			end

	end

	for ii,vv in ipairs(arcenemies) do             -- This for loop checks to see if any player bullets are colliding with the enemies
		for i,v in ipairs(bullet) do			-- and then removes both the enemie and the bullet from the screen and table
			if  (v.x + v.width) >= vv.x and
			v.x <= (vv.x + vv.width) and
			(v.y + v.height) >= vv.y and
			v.y <= (vv.y + vv.height) then
					upgradeAvailable = true
					player.score = player.score + 10
					player.streak = player.streak + 1
					vv.isDead = true
					table.remove(arcenemies, ii)
					table.remove(bullet, i)		-- enemies are removed in the weapons.lua file


			end
		end
	end



	for ii,vv in ipairs(enemies) do             -- This for loop checks to see if any player bullets are colliding with the enemies
		for i,v in ipairs(bullet) do			-- and then removes both the enemie and the bullet from the screen and table
			if  (v.x + v.width) >= vv.x and
			v.x <= (vv.x + vv.width) and
			(v.y + v.height) >= vv.y and
			v.y <= (vv.y + vv.height) then
					upgradeAvailable = true
					player.score = player.score + 10
					player.streak = player.streak + 1
					vv.isDead = true
					table.remove(bullet, i)		-- enemies are removed in the weapons.lua file


			end
		end
	end


	for ii,vv in ipairs(enemies) do				-- This for loop checks to see if any player rockets are colliding with the enemies
		for i,v in ipairs(rocket) do			-- and then removes both the enemie and the bullet from the screen and table
			if  (v.x + v.width) >= vv.x and
			v.x <= (vv.x + vv.width) and
			(v.y + v.height) >= vv.y and
			v.y <= (vv.y + vv.height) then

					upgradeAvailable = true
					vv.isDead = true

					player.score = player.score + 10
					player.streak = player.streak + 1
					table.remove(rocket, i)		-- enemies are removed in the weapons.lua file

			end
		end
	end

	for ii,vv in ipairs(enemies) do					-- This for loop checks to see if any quad rockets are colliding with the enemies
		for i,v in ipairs(quadrockets) do			-- and then removes both the enemie and that rocket from the screen and table
			if  (v.x + v.width) >= vv.x and
			v.x <= (vv.x + vv.width) and
			(v.y + v.height) >= vv.y and
			v.y <= (vv.y + vv.height) then

					upgradeAvailable = true
					vv.isDead = true

					player.score = player.score + 10
					player.streak = player.streak + 1
					table.remove(quadrockets, i)		-- enemies are removed in the weapons.lua file

			end
		end
	end

	for ii,vv in ipairs(enemies) do						-- This checks to see if any heavymachineGun bullets have hit an enemey.
		for i,v in ipairs(heavymachineGun) do			-- and then removes both the enemie and the bullet from the screen and table
			if  (v.x + v.width) >= vv.x and
			v.x <= (vv.x + vv.width) and
			(v.y + v.height) >= vv.y and
			v.y <= (vv.y + vv.height) then

					upgradeAvailable = true
					vv.isDead = true

					player.score = player.score + 10
					player.streak = player.streak + 1
					table.remove(heavymachineGun , i)	-- enemies are removed in the weapons.lua file

			end
		end
	end


	for ii,vv in ipairs(enemies) do
			if  (player.x + player.width) >= vv.x and	-- This code checks whether the player and an enemy have physically collided
				player.x <= (vv.x + vv.width) and
				(player.y + player.height) >= vv.y and
				player.y <= (vv.y + vv.height) then
				player.health = player.health - 1
				player.streak = 0
				table.remove(enemies, ii)				-- enemies are removed here, because you dont get an upgrade if you destroy an enemy
			end											-- by colliding with it
	end
end
















-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
--------------------------- File Based UPDATE and DRAW Functions --------------------
--------------------------- put all functions from above in these -------------------
--------------------------- to keep main.lua clear and easily read ------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------


function collisionsUPDATE(dt)

			collisionUpdate(dt)


end

function collisionsDRAW()



end


