require('player')

--------------------- Tank -------------------------


tanks = {}
tanks.x = 100
tanks.y = 100
tanks.health = 10

tank_speed = 100


tankheatseekers = {}


tankspawntimer = 0
function tankAppear(dt)
	tankspawntimer = tankspawntimer + dt
	if tankspawntimer >= 5 then
    tankSpawn(100, 100, "left")
    tankspawntimer = 0

  end
end

function tankSpawn(x,y,dir) 		-- this function actually spawns/generates the enemies
	table.insert(tanks, {width = 75, height = 50, x = 620, y = 270, dir = "left", timer = 5})
end






function tanksMove(dt)					    -- This function and for loop sets the enemy speed, and also removes any enemies that
	for ii, vv in ipairs(tanks) do			-- are below 600 pixels on the y axis
		if vv.dir == "left" then
			vv.x = vv.x - (tank_speed) * dt
		end
		if vv.dir == "right" then
			vv.x = vv.x + (tank_speed) * dt
		end
		if vv.x < -100 then
			table.remove(tanks, ii)
		end
		if vv.x > 650 then
			table.remove(tanks, ii)
		end
	end
end

function tanksDraw()
	for i,v in ipairs(tanks) do
				love.graphics.setColor(0,255,0)
					love.graphics.rectangle("fill", v.x, v.y, v.width, v.height)
				love.graphics.setColor(255,255,255)
				love.graphics.setColor(0,0,0)
					love.graphics.rectangle("line", v.x, v.y, v.width, v.height)
				love.graphics.setColor(255,255,255)
				love.graphics.setColor(0,125,0)
					love.graphics.circle("fill", v.x + v.width/2, v.y + v.width/3, 15, 25)
				love.graphics.setColor(255,255,255)
	end
end




tankbullet_speed = 400
tankbullets = {}

function tankbulletsSpawn(x,y,dir)
	table.insert(tankbullets, {width = 8, height = 8, x = x + 35, y = y + 25, dir = dir})

end

	function tankFiringupdate(dt)
		for i,v in ipairs(tanks) do
				v.timer = v.timer + 1
				if v.timer > 30 then
					tankbulletsSpawn(v.x, v.y, "down")
					v.timer = 0
				end
		end
	end

function tankbulletsDraw()							-- this code draws the enemy bullets to the screen
	for i,v in ipairs(tankbullets) do
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill", v.x,v.y,v.width,v.height)
		love.graphics.setColor(255,255,255)
	end
end

function tankBullets(dt)
		for i,v in ipairs(tankbullets) do
				if v.dir == "down" then
							distX =  player.x - v.x
							distY =  player.y - v.y
							distance = math.sqrt(distX*distX+distY*distY)
							velocityX = distX/distance*tankbullet_speed
							velocityY = distY/distance*tankbullet_speed
							v.x = v.x + velocityX*dt
							v.y = v.y + velocityY*dt
				end
					if v.y > 800 then
							table.remove(tankbullets, i)
					end

	end
end













function tanksUPDATE(dt)
			tanksMove(dt)
			tankAppear(dt)

			tankBullets(dt)
			tankFiringupdate(dt)
end

function tanksDRAW()
			tanksDraw()

end
